/* 
 * ftelnetd - fake telnet daemon
 *
 * banner.h
 *
 * Tue Dec 12 22:47:31 CET 2006
 *
 * by Levent Kayan
 * levent[at]corehack[dot]org
 * www.corehack.org
 */

#ifndef __banner_h_
#define __banner_h_

/* supported targets for ftelnetd: fake modes */
typedef struct {
   char *fake_modes;
} fake_mode;

/* fake banner */
typedef struct {
   int user_retries;          /* max user retries */
   int pass_retries;          /* max pass retries */
   char *b_type;              /* router/telnetd type */
   char *telnet_data;         /* telnet IACs and banner  */
   char *user_string;         /* user format */
   char *pass_string;         /* pass format */
   char *ad_msg;              /* "access denied" message */
   unsigned char echo_char;   /* echo char */
   int time_out;              /* timeout -> RST */
   char *timeout_msg;         /* timeout message */
   int timeout_flag;          /* check for "pass_wrong"-messages */
} banner_t;

extern fake_mode target[];
extern banner_t banner[];

/* prints available modes */
void print_modes();

#endif

/* EOF */
