/*
 * ftelnetd - fake telnet daemon
 * 
 * ftelnetd.h
 *
 * Tue Dec 12 22:47:31 CET 2006
 *
 * by Levent Kayan
 * levent[at]corehack[dot]org
 * www.corehack.org
 */

#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>


#ifndef __FTELNETD_H__
#define __FTELNETD_H__

/* default port to bind the server to */
#define DEFPORT 23

/* just shorten */
#define SA struct sockaddr

/* flogind version */
#define VERSION "ftelnetd v0.0.2"

/* just for usage/help output */
void usage(char *);

/* builds the server only */
int build_server(uint16_t, gid_t, uid_t);

/* drop privilege */
void drop_privs(gid_t, uid_t);

/* data handling */
unsigned char get_byte(int);
void get_line(int, char *, unsigned int, unsigned char);

/* fakes login for telnetd and router */
int fake_login(struct sockaddr_in, int);

/* fakes banner message */
int fake_banner_msg();

/* fakes user string and get user */
char *fake_get_user(int);

/* fakes pass string and get pass*/
char *fake_get_pass(int);

/* our own daemon() function */
int daemon_init();

extern int mode;

#endif

/* EOF */
